   //////////////////////////////////////////////
  //     ART DECO ANALOG THERMOMETER          //
 //                v 1.0                     //
//           http://www.educ8s.tv           //
/////////////////////////////////////////////

#include <OneWire.h>
#include <DallasTemperature.h>

#define ONE_WIRE_BUS 2
int counter = 0;

OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);

int MIN_TEMP = 10;
int MAX_TEMP = 30;

void setup() {

pinMode(9,OUTPUT);
pinMode(12,OUTPUT);
Serial.begin(9600);
sensors.begin();

}

void loop() {

  float temperature = getTemperature();
  int lightIntensity = getLightIntensity();
  
  if(lightIntensity < 30 && counter<60)
  {
    counter++;
    digitalWrite(12,HIGH);   
  }
  else if(lightIntensity < 30 && counter>=60)
  {
    digitalWrite(12,LOW);
  }
  else if(lightIntensity >= 30)
  {
    counter = 0;
    digitalWrite(12,LOW);
  }
  
  int voltage = temperatureToPWM(temperature);
  analogWrite(9,voltage);
  delay(1000);
}

float getTemperature()
{
  float temperature =0;
  sensors.requestTemperatures(); // Send the command to get temperatures
  temperature = sensors.getTempCByIndex(0);
  Serial.print("Temperature: ");
  Serial.println(temperature);
  return temperature;
}

int getLightIntensity()
{
  int lightIntensity = analogRead(0);
  lightIntensity = map(lightIntensity,0,160,100,0);
  return lightIntensity;
}

int temperatureToPWM(float temperature)
{
  float temp=0;
  float voltage = 0;
  temp = temperature*10;
  voltage = map(temp,MIN_TEMP*10,MAX_TEMP*10,0,250);
  return voltage;
}
